import { QueryFn } from '@angular/fire/firestore';
import { Observable } from 'rxjs';
import { CollectionService, CollectionState } from '../collection';
export declare type TypeofArray<T> = T extends (infer X)[] ? X : T;
export declare type Query<T> = {
    path: string;
    queryFn?: QueryFn;
} & SubQueries<TypeofArray<T>>;
export declare type QueryLike<T> = Query<T> | Query<T>[];
export declare type SubQueries<T> = {
    [K in keyof Partial<T>]: (QueryLike<T[K]> | T[K]) | ((entity: T) => QueryLike<T[K]> | T[K]);
};
export declare function isDocPath(path: string): boolean;
/** Transform a path into a collection Query */
export declare function collection<T = any>(path: string, queryFn?: QueryFn): Query<T[]>;
/** Transform a path into a doc query */
export declare function doc<T = any>(path: string): Query<T>;
/**
 * Sync the collection
 * @param this Uses this function with bind on a Collection Service
 * @param query The query to trigger
 */
export declare function syncQuery<E>(this: CollectionService<CollectionState<E>>, query: Query<E>): Observable<any>;
